Index: /pjproject/branches/symbian/pjlib/src/pj/os_symbian.h
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/os_symbian.h	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/os_symbian.h	(revision 789)
@@ -167,6 +167,6 @@
 
 private:
-    RTimer timer_;
-    bool   hasTimedOut_;
+    RTimer	timer_;
+    pj_bool_t	hasTimedOut_;
 
     CPjTimeoutTimer();
@@ -279,4 +279,5 @@
     {
 	TInt aError;
+	User::WaitForAnyRequest();
 	CActiveScheduler::RunIfReady(aError, aPriority);
     }
@@ -295,5 +296,4 @@
 private:
     PjSymbianOS();
-    
 };
 
Index: /pjproject/branches/symbian/pjlib/src/pj/pool.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/pool.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/pool.c	(revision 789)
@@ -178,5 +178,5 @@
 
     /* Allocate initial block */
-    buffer = (*f->policy.block_alloc)(f, initial_size);
+    buffer = (unsigned char*) (*f->policy.block_alloc)(f, initial_size);
     if (!buffer)
 	return NULL;
Index: /pjproject/branches/symbian/pjlib/src/pj/pool_caching.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/pool_caching.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/pool_caching.c	(revision 789)
@@ -74,5 +74,5 @@
     /* Delete all pool in free list */
     for (i=0; i < PJ_CACHING_POOL_ARRAY_SIZE; ++i) {
-	pj_pool_t *pool = cp->free_list[i].next;
+	pj_pool_t *pool = (pj_pool_t*)cp->free_list[i].next;
 	pj_pool_t *next;
 	for (; pool != (void*)&cp->free_list[i]; pool = next) {
@@ -84,5 +84,5 @@
 
     /* Delete all pools in used list */
-    pool = cp->used_list.next;
+    pool = (pj_pool_t*)cp->used_list.next;
     while (pool != (pj_pool_t*) &cp->used_list) {
 	pj_pool_t *next = pool->next;
@@ -141,5 +141,5 @@
     } else {
 	/* Get one pool from the list. */
-	pool = cp->free_list[idx].next;
+	pool = (pj_pool_t*) cp->free_list[idx].next;
 	pj_list_erase(pool);
 
@@ -230,5 +230,5 @@
 			     cp->capacity, cp->max_capacity, cp->used_count));
     if (detail) {
-	pj_pool_t *pool = cp->used_list.next;
+	pj_pool_t *pool = (pj_pool_t*) cp->used_list.next;
 	pj_uint32_t total_used = 0, total_capacity = 0;
         PJ_LOG(3,("cachpool", "  Dumping all active pools:"));
Index: /pjproject/branches/symbian/pjlib/src/pj/sock_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/sock_symbian.cpp	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/sock_symbian.cpp	(revision 789)
@@ -567,7 +567,4 @@
     RSocket &rSock = pjSock->Socket();
 
-    // Socket must be connected.
-    PJ_ASSERT_RETURN(pjSock->IsConnected(), PJ_EINVALIDOP);
-
     TInetAddr inetAddr;
     rSock.LocalName(inetAddr);
Index: /pjproject/branches/symbian/pjlib/src/pj/timer.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/timer.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/timer.c	(revision 789)
@@ -245,5 +245,5 @@
     pj_timer_entry **new_heap = 0;
     
-    new_heap = pj_pool_alloc(ht->pool, sizeof(pj_timer_entry*) * new_size);
+    new_heap = (pj_timer_entry **) pj_pool_alloc(ht->pool, sizeof(pj_timer_entry*) * new_size);
     memcpy(new_heap, ht->heap, ht->max_size * sizeof(pj_timer_entry*));
     //delete [] this->heap_;
@@ -253,5 +253,5 @@
     
     new_timer_ids = 0;
-    new_timer_ids = pj_pool_alloc(ht->pool, new_size * sizeof(pj_timer_id_t));
+    new_timer_ids = (pj_timer_id_t*) pj_pool_alloc(ht->pool, new_size * sizeof(pj_timer_id_t));
     
     memcpy( new_timer_ids, ht->timer_ids, ht->max_size * sizeof(pj_timer_id_t));
@@ -360,5 +360,5 @@
 
     /* Allocate timer heap data structure from the pool */
-    ht = pj_pool_alloc(pool, sizeof(pj_timer_heap_t));
+    ht = (pj_timer_heap_t*) pj_pool_alloc(pool, sizeof(pj_timer_heap_t));
     if (!ht)
         return PJ_ENOMEM;
@@ -376,10 +376,10 @@
 
     // Create the heap array.
-    ht->heap = pj_pool_alloc(pool, sizeof(pj_timer_entry*) * size);
+    ht->heap = (pj_timer_entry **) pj_pool_alloc(pool, sizeof(pj_timer_entry*) * size);
     if (!ht->heap)
         return PJ_ENOMEM;
 
     // Create the parallel
-    ht->timer_ids = pj_pool_alloc( pool, sizeof(pj_timer_id_t) * size);
+    ht->timer_ids = (pj_timer_id_t*) pj_pool_alloc( pool, sizeof(pj_timer_id_t) * size);
     if (!ht->timer_ids)
         return PJ_ENOMEM;
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/atomic.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/atomic.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/atomic.c	(revision 789)
@@ -19,4 +19,5 @@
 #include "test.h"
 #include <pj/os.h>
+#include <pj/pool.h>
 
 /**
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_tcp.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_tcp.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_tcp.c	(revision 789)
@@ -18,4 +18,5 @@
  */
 #include "test.h"
+#include <pj/os.h>
 
 /**
@@ -414,6 +415,6 @@
     pj_pool_release(pool);
     return status;
-
-}
+}
+
 
 /*
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/main_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/main_symbian.cpp	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/main_symbian.cpp	(revision 789)
@@ -52,5 +52,9 @@
     // add your program code here, example code below
     //
-    test_main();
+    int rc = test_main();
+
+    console->Printf(_L(" [press any key]\n"));
+    console->Getch();
+
     CActiveScheduler::Stop();
 }
@@ -142,9 +146,4 @@
 
     CActiveScheduler::Start();
-
-    // Delete active scheduler
-    //CActiveScheduler::Install(NULL);
-    scheduler->Stop();
-    //delete scheduler;
     }
 
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/string_test.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/string_test.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/string_test.c	(revision 789)
@@ -236,4 +236,5 @@
     }
 
+    if (c2 == 0) c2 = 1;
     PJ_LOG(3, ("", "  time: stricmp=%u, stricmp_alnum=%u (speedup=%d.%02dx)", 
 		   c1, c2,
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/test.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/test.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/test.c	(revision 789)
@@ -44,6 +44,5 @@
 const char *param_echo_server = ECHO_SERVER_ADDRESS;
 int param_echo_port = ECHO_SERVER_START_PORT;
-int param_log_decor = PJ_LOG_HAS_NEWLINE | PJ_LOG_HAS_TIME | 
-		      PJ_LOG_HAS_MICRO_SEC;
+int param_log_decor = PJ_LOG_HAS_NEWLINE;
 
 int null_func()
@@ -186,5 +185,5 @@
     pj_caching_pool_destroy( &caching_pool );
 
-    PJ_LOG(3,("test", ""));
+    PJ_LOG(3,("test", " "));
  
     pj_thread_get_stack_info(pj_thread_this(), &filename, &line);
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/test.h
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/test.h	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/test.h	(revision 789)
@@ -22,7 +22,7 @@
 #include <pj/types.h>
 
-#define GROUP_LIBC                  0
-#define GROUP_OS                    0
-#define GROUP_DATA_STRUCTURE        0
+#define GROUP_LIBC                  1
+#define GROUP_OS                    1
+#define GROUP_DATA_STRUCTURE        1
 #define GROUP_NETWORK               1
 #define GROUP_FILE                  0
@@ -34,7 +34,7 @@
 #define INCLUDE_LIST_TEST	    GROUP_DATA_STRUCTURE
 #define INCLUDE_POOL_TEST	    GROUP_LIBC
-#define INCLUDE_POOL_PERF_TEST	    0	// (PJ_HAS_MALLOC && GROUP_LIBC)
-#define INCLUDE_STRING_TEST	    0	// GROUP_DATA_STRUCTURE
-#define INCLUDE_FIFOBUF_TEST	    0	// GROUP_DATA_STRUCTURE
+#define INCLUDE_POOL_PERF_TEST	    (PJ_HAS_MALLOC && GROUP_LIBC)
+#define INCLUDE_STRING_TEST	    GROUP_DATA_STRUCTURE
+#define INCLUDE_FIFOBUF_TEST	    GROUP_DATA_STRUCTURE
 #define INCLUDE_RBTREE_TEST	    GROUP_DATA_STRUCTURE
 #define INCLUDE_TIMER_TEST	    GROUP_DATA_STRUCTURE
@@ -43,10 +43,10 @@
 #define INCLUDE_SLEEP_TEST          GROUP_OS
 #define INCLUDE_THREAD_TEST         (PJ_HAS_THREADS && GROUP_OS)
-#define INCLUDE_SOCK_TEST	    0 	// GROUP_NETWORK
-#define INCLUDE_SOCK_PERF_TEST      0	// GROUP_NETWORK
-#define INCLUDE_SELECT_TEST	    0	// GROUP_NETWORK
+#define INCLUDE_SOCK_TEST	    GROUP_NETWORK
+#define INCLUDE_SOCK_PERF_TEST      GROUP_NETWORK
+#define INCLUDE_SELECT_TEST	    GROUP_NETWORK
 #define INCLUDE_UDP_IOQUEUE_TEST    GROUP_NETWORK
 #define INCLUDE_TCP_IOQUEUE_TEST    GROUP_NETWORK
-#define INCLUDE_IOQUEUE_PERF_TEST   GROUP_NETWORK
+#define INCLUDE_IOQUEUE_PERF_TEST   (PJ_HAS_THREADS && GROUP_NETWORK)
 #define INCLUDE_IOQUEUE_UNREG_TEST  0	// GROUP_NETWORK
 #define INCLUDE_FILE_TEST           GROUP_FILE
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 789)
@@ -19,6 +19,8 @@
 #include <pj/errno.h>
 #include <pj/ioqueue.h>
+#include <pj/os.h>
 #include <pj/pool.h>
 #include <pj/sock.h>
+#include <pj/string.h>
 #include "test.h"
 
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_sync.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 789)
@@ -20,4 +20,5 @@
 #include <pj/errno.h>
 #include <pj/ioqueue.h>
+#include <pj/log.h>
 #include <pj/os.h>
 #include <pj/pool.h>
Index: /pjproject/branches/symbian/pjmedia/include/pjmedia/config.h
===================================================================
--- /pjproject/branches/symbian/pjmedia/include/pjmedia/config.h	(revision 788)
+++ /pjproject/branches/symbian/pjmedia/include/pjmedia/config.h	(revision 789)
@@ -37,4 +37,6 @@
 #  if defined(PJ_WIN32) && PJ_WIN32!=0
 #   define PJMEDIA_SOUND_IMPLEMENTATION	    PJMEDIA_SOUND_WIN32_DIRECT_SOUND
+#  elif defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
+#   define PJMEDIA_SOUND_IMPLEMENTATION	    PJMEDIA_SOUND_NULL_SOUND
 #  else
 #   define PJMEDIA_SOUND_IMPLEMENTATION	    PJMEDIA_SOUND_PORTAUDIO_SOUND
Index: /pjproject/branches/symbian/pjmedia/src/pjmedia/errno.c
===================================================================
--- /pjproject/branches/symbian/pjmedia/src/pjmedia/errno.c	(revision 788)
+++ /pjproject/branches/symbian/pjmedia/src/pjmedia/errno.c	(revision 789)
@@ -20,5 +20,8 @@
 #include <pjmedia/types.h>
 #include <pj/string.h>
-#include <portaudio.h>
+
+#if PJMEDIA_SOUND_IMPLEMENTATION==PJMEDIA_SOUND_PORTAUDIO_SOUND
+#   include <portaudio.h>
+#endif
 
 
Index: /pjproject/branches/symbian/pjmedia/src/pjmedia/sdp.c
===================================================================
--- /pjproject/branches/symbian/pjmedia/src/pjmedia/sdp.c	(revision 788)
+++ /pjproject/branches/symbian/pjmedia/src/pjmedia/sdp.c	(revision 789)
@@ -93,5 +93,5 @@
     PJ_ASSERT_RETURN(pool && name, NULL);
 
-    attr = pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
+    attr = (pjmedia_sdp_attr*) pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
     pj_strdup2(pool, &attr->name, name);
 
@@ -113,5 +113,5 @@
     PJ_ASSERT_RETURN(pool && rhs, NULL);
 
-    attr = pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
+    attr = (pjmedia_sdp_attr*) pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
 
     pj_strdup(pool, &attr->name, &rhs->name);
@@ -365,5 +365,5 @@
     PJ_ASSERT_RETURN(pool && attr && p_rtpmap, PJ_EINVAL);
 
-    *p_rtpmap = pj_pool_alloc(pool, sizeof(pjmedia_sdp_rtpmap));
+    *p_rtpmap = (pjmedia_sdp_rtpmap*) pj_pool_alloc(pool, sizeof(pjmedia_sdp_rtpmap));
     PJ_ASSERT_RETURN(*p_rtpmap, PJ_ENOMEM);
 
@@ -394,5 +394,5 @@
     }
 
-    attr = pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
+    attr = (pjmedia_sdp_attr*) pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
     PJ_ASSERT_RETURN(attr != NULL, PJ_ENOMEM);
 
@@ -431,5 +431,5 @@
 
     attr->value.slen = p-tempbuf;
-    attr->value.ptr = pj_pool_alloc(pool, attr->value.slen);
+    attr->value.ptr = (char*)pj_pool_alloc(pool, attr->value.slen);
     pj_memcpy(attr->value.ptr, tempbuf, attr->value.slen);
 
@@ -465,5 +465,5 @@
 						  const pjmedia_sdp_conn *rhs)
 {
-    pjmedia_sdp_conn *c = pj_pool_alloc (pool, sizeof(pjmedia_sdp_conn));
+    pjmedia_sdp_conn *c = (pjmedia_sdp_conn*) pj_pool_alloc (pool, sizeof(pjmedia_sdp_conn));
     if (!c) return NULL;
 
@@ -559,5 +559,5 @@
 {
     unsigned int i;
-    pjmedia_sdp_media *m = pj_pool_alloc (pool, sizeof(pjmedia_sdp_media));
+    pjmedia_sdp_media *m = (pjmedia_sdp_media*) pj_pool_alloc (pool, sizeof(pjmedia_sdp_media));
     PJ_ASSERT_RETURN(m != NULL, NULL);
 
@@ -896,5 +896,5 @@
     ctx->last_error = PJMEDIA_SDP_EINATTR;
 
-    attr = pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
+    attr = (pjmedia_sdp_attr*)pj_pool_alloc(pool, sizeof(pjmedia_sdp_attr));
 
     /* skip a= */
@@ -928,5 +928,5 @@
     pjmedia_sdp_session *session;
     pjmedia_sdp_media *media = NULL;
-    void *attr;
+    pjmedia_sdp_attr *attr;
     pjmedia_sdp_conn *conn;
     pj_str_t dummy;
@@ -940,5 +940,5 @@
 
     pj_scan_init(&scanner, buf, len, 0, &on_scanner_error);
-    session = pj_pool_calloc(pool, 1, sizeof(pjmedia_sdp_session));
+    session = (pjmedia_sdp_session*)pj_pool_calloc(pool, 1, sizeof(pjmedia_sdp_session));
     PJ_ASSERT_RETURN(session != NULL, PJ_ENOMEM);
 
@@ -964,5 +964,5 @@
 		    break;
 		case 'c':
-		    conn = pj_pool_calloc(pool, 1, sizeof(*conn));
+		    conn = (pjmedia_sdp_conn*) pj_pool_calloc(pool, 1, sizeof(*conn));
 		    parse_connection_info(&scanner, conn, &ctx);
 		    if (media) {
@@ -976,5 +976,5 @@
 		    break;
 		case 'm':
-		    media = pj_pool_calloc(pool, 1, sizeof(*media));
+		    media = (pjmedia_sdp_media*) pj_pool_calloc(pool, 1, sizeof(*media));
 		    parse_media(&scanner, media, &ctx);
 		    session->media[ session->media_count++ ] = media;
@@ -992,5 +992,5 @@
 
     }
-    PJ_CATCH(SYNTAX_ERROR) {
+    PJ_CATCH_ANY {
 	
 	char errmsg[PJ_ERR_MSG_SIZE];
@@ -1034,5 +1034,5 @@
     PJ_ASSERT_RETURN(pool && rhs, NULL);
 
-    sess = pj_pool_zalloc(pool, sizeof(pjmedia_sdp_session));
+    sess = (pjmedia_sdp_session*)pj_pool_zalloc(pool, sizeof(pjmedia_sdp_session));
     PJ_ASSERT_RETURN(sess != NULL, NULL);
 
Index: /pjproject/branches/symbian/pjmedia/src/pjmedia/sdp_neg.c
===================================================================
--- /pjproject/branches/symbian/pjmedia/src/pjmedia/sdp_neg.c	(revision 788)
+++ /pjproject/branches/symbian/pjmedia/src/pjmedia/sdp_neg.c	(revision 789)
@@ -82,5 +82,5 @@
 
     /* Create and initialize negotiator. */
-    neg = pj_pool_zalloc(pool, sizeof(pjmedia_sdp_neg));
+    neg = (pjmedia_sdp_neg*) pj_pool_zalloc(pool, sizeof(pjmedia_sdp_neg));
     PJ_ASSERT_RETURN(neg != NULL, PJ_ENOMEM);
 
@@ -116,5 +116,5 @@
 
     /* Create and initialize negotiator. */
-    neg = pj_pool_zalloc(pool, sizeof(pjmedia_sdp_neg));
+    neg = (pjmedia_sdp_neg*) pj_pool_zalloc(pool, sizeof(pjmedia_sdp_neg));
     PJ_ASSERT_RETURN(neg != NULL, PJ_ENOMEM);
 
@@ -634,5 +634,5 @@
 		 */
 		const pjmedia_sdp_attr *a;
-		pjmedia_sdp_rtpmap or;
+		pjmedia_sdp_rtpmap ormt;
 		pj_bool_t is_codec;
 
@@ -644,7 +644,7 @@
 		    return PJ_FALSE;
 		}
-		pjmedia_sdp_attr_get_rtpmap(a, &or);
-
-		if (!pj_strcmp2(&or.enc_name, "telephone-event")) {
+		pjmedia_sdp_attr_get_rtpmap(a, &ormt);
+
+		if (!pj_strcmp2(&ormt.enc_name, "telephone-event")) {
 		    offer_has_telephone_event = 1;
 		    if (found_matching_telephone_event)
@@ -669,6 +669,6 @@
 
 			/* See if encoding name and clock rate match */
-			if (!pj_strcmp(&or.enc_name, &lr.enc_name) &&
-			    or.clock_rate == lr.clock_rate) 
+			if (!pj_strcmp(&ormt.enc_name, &lr.enc_name) &&
+			    ormt.clock_rate == lr.clock_rate) 
 			{
 			    /* Match! */
Index: /pjproject/branches/symbian/pjsip-apps/src/samples/main_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjsip-apps/src/samples/main_symbian.cpp	(revision 789)
+++ /pjproject/branches/symbian/pjsip-apps/src/samples/main_symbian.cpp	(revision 789)
@@ -0,0 +1,172 @@
+#include <stdlib.h>
+#include <stdio.h>
+#include <e32std.h>
+#include <e32base.h>
+#include <e32std.h>
+#include <e32cons.h>            // Console
+
+/* PJLIB Unicode conversion */
+#include <pj/unicode.h>
+
+/* Log writing */
+#include <pj/log.h>
+
+
+/* This will be defined in application's code */
+extern "C"
+{
+	int pj_app_main(int argc, char *argv[]);
+}
+
+
+
+//  Global Variables
+
+LOCAL_D CConsoleBase* console;  // write all messages to this
+
+
+//  Local Functions
+
+LOCAL_C void MainL()
+{
+    //
+    // add your program code here, example code below
+    //
+    char *argv[] = { "main_symbian", NULL };
+    int rc = pj_app_main(1, argv);
+
+    console->Printf(_L(" [press any key]\n"));
+    console->Getch();
+
+    CActiveScheduler::Stop();
+}
+
+class MyScheduler : public CActiveScheduler
+{
+public:
+    MyScheduler()
+    {}
+
+    void Error(TInt aError) const;
+};
+
+void MyScheduler::Error(TInt aError) const
+{
+    int i = 0;
+}
+
+class ProgramStarter : public CActive
+{
+public:
+    static ProgramStarter *NewL();
+    void Start();
+
+protected:
+    ProgramStarter();
+    void ConstructL();
+    virtual void RunL();
+    virtual void DoCancel();
+    TInt RunError(TInt aError);
+
+private:
+    RTimer timer_;
+};
+
+ProgramStarter::ProgramStarter()
+: CActive(EPriorityNormal)
+{
+}
+
+void ProgramStarter::ConstructL()
+{
+    timer_.CreateLocal();
+    CActiveScheduler::Add(this);
+}
+
+ProgramStarter *ProgramStarter::NewL()
+{
+    ProgramStarter *self = new (ELeave) ProgramStarter;
+    CleanupStack::PushL(self);
+
+    self->ConstructL();
+
+    CleanupStack::Pop(self);
+    return self;
+}
+
+void ProgramStarter::Start()
+{
+    timer_.After(iStatus, 0);
+    SetActive();
+}
+
+void ProgramStarter::RunL()
+{
+    MainL();
+}
+
+void ProgramStarter::DoCancel()
+{
+}
+
+TInt ProgramStarter::RunError(TInt aError)
+{
+    PJ_UNUSED_ARG(aError);
+    return KErrNone;
+}
+
+
+LOCAL_C void DoStartL()
+{
+    // Create active scheduler (to run active objects)
+    CActiveScheduler* scheduler = new (ELeave) MyScheduler;
+    CleanupStack::PushL(scheduler);
+    CActiveScheduler::Install(scheduler);
+
+    ProgramStarter *starter = ProgramStarter::NewL();
+    starter->Start();
+
+    CActiveScheduler::Start();
+}
+
+
+//  Global Functions
+
+static void log_writer(int level, const char *buf, int len)
+{
+    wchar_t buf16[PJ_LOG_MAX_SIZE];
+
+    pj_ansi_to_unicode(buf, len, buf16, PJ_ARRAY_SIZE(buf16));
+
+    TPtrC16 aBuf((const TUint16*)buf16, (TInt)len);
+    console->Write(aBuf);
+}
+
+
+GLDEF_C TInt E32Main()
+{
+    // Create cleanup stack
+    __UHEAP_MARK;
+    CTrapCleanup* cleanup = CTrapCleanup::New();
+
+    // Create output console
+    TRAPD(createError, console = Console::NewL(_L("Console"), TSize(KConsFullScreen,KConsFullScreen)));
+    if (createError)
+        return createError;
+
+    pj_log_set_log_func(&log_writer);
+
+    // Run application code inside TRAP harness, wait keypress when terminated
+    TRAPD(mainError, DoStartL());
+    if (mainError)
+        console->Printf(_L(" failed, leave code = %d"), mainError);
+    console->Printf(_L(" [press any key]\n"));
+    console->Getch();
+    
+    delete console;
+    delete cleanup;
+    __UHEAP_MARKEND;
+    return KErrNone;
+}
+
+
Index: /pjproject/branches/symbian/pjsip-apps/src/samples/sipstateless.c
===================================================================
--- /pjproject/branches/symbian/pjsip-apps/src/samples/sipstateless.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip-apps/src/samples/sipstateless.c	(revision 789)
@@ -32,4 +32,5 @@
 #include <pjlib-util.h>
 #include <pjlib.h>
+#include "../../../pjlib/src/pj/os_symbian.h"
 
 
@@ -62,9 +63,23 @@
 
 
+extern "C"
+{
+	int pj_app_main(int argc, char *argv[]);
+}
+
+
+static void app_perror(pj_status_t status)
+{
+    char errmsg[PJ_ERR_MSG_SIZE];
+    pj_strerror(status, errmsg, sizeof(errmsg));
+    PJ_LOG(1,("main", "Error: %s", errmsg));
+}
+
+
 /*
- * main()
+ * pj_app_main()
  *
  */
-int main()
+int pj_app_main(int argc, char *argv[])
 {
     pj_caching_pool cp;
@@ -93,5 +108,4 @@
     PJ_ASSERT_RETURN(status == PJ_SUCCESS, 1);
 
-
     /* Then init PJLIB-UTIL: */
     status = pjlib_util_init();
@@ -99,5 +113,5 @@
 
     /* Must create a pool factory before we can allocate any memory. */
-    pj_caching_pool_init(&cp, &pj_pool_factory_default_policy, 0);
+    pj_caching_pool_init(&cp, pj_pool_factory_get_default_policy(), 0);
 
 
@@ -135,6 +149,9 @@
 	status = pjsip_udp_transport_start( sip_endpt, &addr, NULL, 1, NULL);
 	if (status != PJ_SUCCESS) {
+	    char errmsg[PJ_ERR_MSG_SIZE];
+
+	    pj_strerror(status, errmsg, sizeof(errmsg));
 	    PJ_LOG(3,(THIS_FILE, 
-		      "Error starting UDP transport (port in use?)"));
+		      "Error starting UDP transport: %s", errmsg));
 	    return 1;
 	}
Index: /pjproject/branches/symbian/pjsip/include/pjsip-ua/sip_inv.h
===================================================================
--- /pjproject/branches/symbian/pjsip/include/pjsip-ua/sip_inv.h	(revision 788)
+++ /pjproject/branches/symbian/pjsip/include/pjsip-ua/sip_inv.h	(revision 789)
@@ -27,5 +27,4 @@
 
 
-typedef enum pjsip_inv_state pjsip_inv_state;
 typedef struct pjsip_inv_session pjsip_inv_session;
 typedef struct pjsip_inv_callback pjsip_inv_callback;
@@ -34,5 +33,5 @@
  * This enumeration describes invite session state.
  */
-enum pjsip_inv_state
+typedef enum pjsip_inv_state
 {
     PJSIP_INV_STATE_NULL,	    /**< Before INVITE is sent or received  */
@@ -43,5 +42,5 @@
     PJSIP_INV_STATE_CONFIRMED,	    /**< After ACK is sent/received.	    */
     PJSIP_INV_STATE_DISCONNECTED,   /**< Session is terminated.		    */
-};
+} pjsip_inv_state;
 
 /**
Index: /pjproject/branches/symbian/pjsip/include/pjsip/print_util.h
===================================================================
--- /pjproject/branches/symbian/pjsip/include/pjsip/print_util.h	(revision 788)
+++ /pjproject/branches/symbian/pjsip/include/pjsip/print_util.h	(revision 789)
@@ -106,8 +106,8 @@
 PJ_INLINE(void) init_hdr(void *hptr, pjsip_hdr_e htype, void *vptr)
 {
-    pjsip_hdr *hdr = hptr;
+    pjsip_hdr *hdr = (pjsip_hdr*) hptr;
     hdr->type = htype;
     hdr->name = hdr->sname = pjsip_hdr_names[htype];
-    hdr->vptr = vptr;
+    hdr->vptr = (pjsip_hdr_vptr*) vptr;
     pj_list_init(hdr);
 }
Index: /pjproject/branches/symbian/pjsip/include/pjsip/sip_dialog.h
===================================================================
--- /pjproject/branches/symbian/pjsip/include/pjsip/sip_dialog.h	(revision 788)
+++ /pjproject/branches/symbian/pjsip/include/pjsip/sip_dialog.h	(revision 789)
@@ -53,9 +53,9 @@
  * Dialog state.
  */
-enum pjsip_dialog_state
+typedef enum pjsip_dialog_state
 {
     PJSIP_DIALOG_STATE_NULL,
     PJSIP_DIALOG_STATE_ESTABLISHED,
-};
+} pjsip_dialog_state;
 
 /**
Index: /pjproject/branches/symbian/pjsip/include/pjsip/sip_types.h
===================================================================
--- /pjproject/branches/symbian/pjsip/include/pjsip/sip_types.h	(revision 788)
+++ /pjproject/branches/symbian/pjsip/include/pjsip/sip_types.h	(revision 789)
@@ -140,9 +140,4 @@
 
 /**
- * Dialog state (sip_dialog.h).
- */
-typedef enum pjsip_dialog_state pjsip_dialog_state;
-
-/**
  * Transaction role.
  */
Index: /pjproject/branches/symbian/pjsip/src/pjsip-simple/evsub_msg.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip-simple/evsub_msg.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip-simple/evsub_msg.c	(revision 789)
@@ -22,5 +22,4 @@
 #include <pj/pool.h>
 #include <pj/string.h>
-#include <pj/except.h>
 
 /*
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_client.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_client.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_client.c	(revision 789)
@@ -213,5 +213,5 @@
     
     /* Allocate memory. */
-    cred->response.ptr = pj_pool_alloc(pool, PJSIP_MD5STRLEN);
+    cred->response.ptr = (char*)pj_pool_alloc(pool, PJSIP_MD5STRLEN);
     cred->response.slen = PJSIP_MD5STRLEN;
 
@@ -228,5 +228,5 @@
 	 */
 	cred->qop = pjsip_AUTH_STR;
-	cred->nc.ptr = pj_pool_alloc(pool, 16);
+	cred->nc.ptr = (char*)pj_pool_alloc(pool, 16);
 	pj_ansi_snprintf(cred->nc.ptr, 16, "%06u", nc);
 
@@ -266,5 +266,6 @@
     if (cached_auth->cnonce.slen == 0) {
 	/* Save the whole challenge */
-	cached_auth->last_chal = pjsip_hdr_clone(ses_pool, hdr);
+	cached_auth->last_chal = (pjsip_www_authenticate_hdr*)
+				  pjsip_hdr_clone(ses_pool, hdr);
 
 	/* Create cnonce */
@@ -366,5 +367,5 @@
     sess->endpt = (pjsip_endpoint*)rhs->endpt;
     sess->cred_cnt = rhs->cred_cnt;
-    sess->cred_info = pj_pool_alloc(pool, 
+    sess->cred_info = (pjsip_cred_info*) pj_pool_alloc(pool, 
 				    sess->cred_cnt*sizeof(pjsip_cred_info));
     for (i=0; i<rhs->cred_cnt; ++i) {
@@ -401,5 +402,6 @@
     } else {
 	int i;
-	sess->cred_info = pj_pool_alloc(sess->pool, cred_cnt * sizeof(*c));
+	sess->cred_info = (pjsip_cred_info*)
+			  pj_pool_alloc(sess->pool, cred_cnt * sizeof(*c));
 	for (i=0; i<cred_cnt; ++i) {
 	    sess->cred_info[i].data_type = c[i].data_type;
@@ -527,5 +529,6 @@
 		cached_hdr->hdr = hauth;
 	    } else {
-		cached_hdr = pj_pool_alloc(pool, sizeof(*cached_hdr));
+		cached_hdr = (pjsip_cached_auth_hdr*)
+			     pj_pool_alloc(pool, sizeof(*cached_hdr));
 		pjsip_method_copy( pool, &cached_hdr->method, method);
 		cached_hdr->hdr = hauth;
@@ -536,5 +539,6 @@
 #	if defined(PJSIP_AUTH_AUTO_SEND_NEXT) && PJSIP_AUTH_AUTO_SEND_NEXT!=0
 	    if (hdr != cached_auth->last_chal) {
-		cached_auth->last_chal = pjsip_hdr_clone(sess_pool, hdr);
+		cached_auth->last_chal = (pjsip_www_authenticate_hdr*)
+					  pjsip_hdr_clone(sess_pool, hdr);
 	    }
 #	endif
@@ -609,5 +613,6 @@
 		    if (pjsip_method_cmp(&entry->method, method)==0) {
 			pjsip_authorization_hdr *hauth;
-			hauth = pjsip_hdr_shallow_clone(tdata->pool, entry->hdr);
+			hauth=(pjsip_authorization_hdr*) 
+			      pjsip_hdr_shallow_clone(tdata->pool, entry->hdr);
 			pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)hauth);
 		    } else {
@@ -795,5 +800,6 @@
 	cached_auth = find_cached_auth(sess, &hchal->challenge.common.realm );
 	if (!cached_auth) {
-	    cached_auth = pj_pool_zalloc( sess->pool, sizeof(*cached_auth));
+	    cached_auth = (pjsip_cached_auth *)
+			  pj_pool_zalloc( sess->pool, sizeof(*cached_auth));
 	    pj_strdup( sess->pool, &cached_auth->realm, &hchal->challenge.common.realm);
 	    cached_auth->is_proxy = (hchal->type == PJSIP_H_PROXY_AUTHENTICATE);
@@ -823,5 +829,6 @@
 
     /* Remove branch param in Via header. */
-    via = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
+    via = (pjsip_via_hdr*)
+	  pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
     via->branch_param.slen = 0;
 
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_msg.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_msg.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_msg.c	(revision 789)
@@ -47,5 +47,6 @@
 PJ_DEF(pjsip_authorization_hdr*) pjsip_authorization_hdr_create(pj_pool_t *pool)
 {
-    pjsip_authorization_hdr *hdr = pj_pool_calloc(pool, 1, sizeof(*hdr));
+    pjsip_authorization_hdr *hdr = (pjsip_authorization_hdr *)
+				    pj_pool_calloc(pool, 1, sizeof(*hdr));
     init_hdr(hdr, PJSIP_H_AUTHORIZATION, &authorization_hdr_vptr);
     pj_list_init(&hdr->credential.common.other_param);
@@ -55,5 +56,6 @@
 PJ_DEF(pjsip_proxy_authorization_hdr*) pjsip_proxy_authorization_hdr_create(pj_pool_t *pool)
 {
-    pjsip_proxy_authorization_hdr *hdr = pj_pool_calloc(pool, 1, sizeof(*hdr));
+    pjsip_proxy_authorization_hdr *hdr = (pjsip_proxy_authorization_hdr *)
+					 pj_pool_calloc(pool, 1, sizeof(*hdr));
     init_hdr(hdr, PJSIP_H_PROXY_AUTHORIZATION, &authorization_hdr_vptr);
     pj_list_init(&hdr->credential.common.other_param);
@@ -173,5 +175,6 @@
 {
     /* This function also serves Proxy-Authorization header. */
-    pjsip_authorization_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_authorization_hdr *hdr = (pjsip_authorization_hdr *)
+				   pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone(pool, &hdr->credential.common.other_param, 
@@ -202,5 +205,6 @@
 PJ_DEF(pjsip_www_authenticate_hdr*) pjsip_www_authenticate_hdr_create(pj_pool_t *pool)
 {
-    pjsip_www_authenticate_hdr *hdr = pj_pool_calloc(pool, 1, sizeof(*hdr));
+    pjsip_www_authenticate_hdr *hdr = (pjsip_www_authenticate_hdr *) 
+				      pj_pool_calloc(pool, 1, sizeof(*hdr));
     init_hdr(hdr, PJSIP_H_WWW_AUTHENTICATE, &www_authenticate_hdr_vptr);
     pj_list_init(&hdr->challenge.common.other_param);
@@ -211,5 +215,6 @@
 PJ_DEF(pjsip_proxy_authenticate_hdr*) pjsip_proxy_authenticate_hdr_create(pj_pool_t *pool)
 {
-    pjsip_proxy_authenticate_hdr *hdr = pj_pool_calloc(pool, 1, sizeof(*hdr));
+    pjsip_proxy_authenticate_hdr *hdr = (pjsip_proxy_authenticate_hdr *)
+				         pj_pool_calloc(pool, 1, sizeof(*hdr));
     init_hdr(hdr, PJSIP_H_PROXY_AUTHENTICATE, &www_authenticate_hdr_vptr);
     pj_list_init(&hdr->challenge.common.other_param);
@@ -323,5 +328,6 @@
 {
     /* This function also serves Proxy-Authenticate header. */
-    pjsip_www_authenticate_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_www_authenticate_hdr *hdr = (pjsip_www_authenticate_hdr *) 
+				       pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone(pool, &hdr->challenge.common.other_param, 
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_parser.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_parser.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_parser.c	(revision 789)
@@ -107,5 +107,6 @@
 
 	} else {
-	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    pjsip_param *p = (pjsip_param *)
+			     pj_pool_alloc(pool, sizeof(pjsip_param));
 	    p->name = name;
 	    p->value = value;
@@ -169,5 +170,6 @@
 
 	} else {
-	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    pjsip_param *p = (pjsip_param *)
+			     pj_pool_alloc(pool, sizeof(pjsip_param));
 	    p->name = name;
 	    p->value = value;
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_server.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_server.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_auth_server.c	(revision 789)
@@ -115,5 +115,5 @@
     pjsip_authorization_hdr *h_auth;
     pjsip_msg *msg = rdata->msg_info.msg;
-    int htype;
+    pjsip_hdr_e htype;
     pj_str_t acc_name;
     pjsip_cred_info cred_info;
